%Heat Transfer Analysis of New Bath Drain, ERN 1304232

clear,clc

% Define distances
dx=5*.0254; %m dy=dx
dz=.125*.0254; %m

%Node establishment and numbers
%node = node establishment array: 1 if node exists, 0 if node DNE, includes 1 row/column/layer of padding zeros for coefficient matrix creation
node={zeros(16,7),ones(16,7),ones(16,7),ones(16,7),zeros(16,7)};
node{2}(1,:)=zeros(1,7);node{3}(1,:)=zeros(1,7);node{4}(1,:)=zeros(1,7);node{2}(16,:)=zeros(1,7);node{3}(16,:)=zeros(1,7);node{4}(16,:)=zeros(1,7);
node{2}(:,1)=zeros(16,1);node{3}(:,1)=zeros(16,1);node{4}(:,1)=zeros(16,1);node{2}(:,7)=zeros(16,1);node{3}(:,7)=zeros(16,1);node{4}(:,7)=zeros(16,1);
%nodemat = matrix version of node
nodemat=cell2mat(node);
%nodematnum = unique node index matrix
nodematnum=nodemat;
i=1;
for n=1:35
for m=1:16
if (nodemat(m,n)==1)
nodematnum(m,n)=i;
i=i+1;
else
end
end
end
nodematnum=nodematnum+1;

%NODE CHECKS
%pre-size matrices
zu=nodemat;zd=zu;xu=zu;xd=zu;yu=zu;yd=zu;
%establish node size (z) and node adjacent? (x,y)
for o=2:4
for n=2:6
for m=2:15
zu(m,n+7*(o-1))=nodemat(m,n+7*(o));
zd(m,n+7*(o-1))=nodemat(m,n+7*(o-2));
yu(m,n+7*(o-1))=nodemat(m,(n+1)+7*(o-1));
yd(m,n+7*(o-1))=nodemat(m,(n-1)+7*(o-1));
xu(m,n+7*(o-1))=nodemat(m+1,(n)+7*(o-1));
xd(m,n+7*(o-1))=nodemat(m-1,(n)+7*(o-1));
end
end
end
z=(zu+zd)/2;

%Define Guess Temps
Th=355; %K
Tc=245; %K
Tk=(355*15*50+245*(100*15))/(15*50+100*15); %K, average over outer surface area

%Define thermal conductivity
k=60.5;

%define T_inf, create matrix M_inf
Tinf=cell2mat({zeros(16,7),[ones(11,4)*Th,ones(11,3)*Tc;ones(5,7)*Tc],zeros(16,7),ones(16,7)*Tk,zeros(16,7)});

%define Ts (guess lower surface temperature)
Ts=cell2mat({zeros(16,7),[ones(11,4)*300,ones(11,3)*250;ones(5,7)*250],zeros(16,7),[ones(11,4)*280,ones(11,3)*260;ones(5,7)*260],zeros(16,7)});

%create convection type check matrix
check=zeros(16,35);
for o=2:4
for n=2:6
for m=2:15
if (Ts(m,n+7*(o-1))==300)
check(m,n+7*(o-1))=1;
elseif (Ts(m,n+7*(o-1))==250)
check(m,n+7*(o-1))=2;
elseif (Ts(m,n+7*(o-1))==260)
check(m,n+7*(o-1))=3;
elseif (Ts(m,n+7*(o-1))==280)
check(m,n+7*(o-1))=4;
else
end
end
end
end

%Define heat transfer coefficient
L=dx/4;

%define h
h=zeros(16,35);
for o=2:4
for n=2:6
for m=2:15
% if (Tinf(m,n+7*(o-1))!=0)
coordinate=[m n o];
indices=[m n+7*(o-1)];
% h(int8(abs(m)),int8(abs(n+7*(o-1))))=h(L,check(m,n+7*(o-1)),Ts(m,n+7*(o-1)), Tinf(m,n+7*(o-1)));
% else
% end
end
end
end
coordinate
indices

%Coefficients and Constants Matrices!
constants=zeros(210,1);C=zeros(210,211);
i=1;
for o=2:4
for n=2:6
for m=2:15
if nodematnum(m,n+7*(o-1))!=1
C(i,nodematnum(m,n+7*(o-1)))= k*2*z(m,n+7*(o-1))*dx^2/dz + k*(xu(m,n+7*(o-1))+xd(m,n+7*(o-1))+yu(m,n+7*(o-1))+yd(m,n+7*(o-1)))*z(m,n+7*(o-1))*dz+h(m,n+7*(o-1))*dx^2;
C(i,nodematnum(m,n+7*(o)))= -zu(m,n+7*(o-1))*dx^2*k/dz;
C(i,nodematnum(m,n+7*(o-2)))= -zd(m,n+7*(o-1))*dx^2*k/dz;
C(i,nodematnum(m,(n+1)+7*(o-1)))= -yu(m,n+7*(o-1))*z(m,n+7*(o-1))*k*dz;
C(i,nodematnum(m,(n-1)+7*(o-1)))= -yd(m,n+7*(o-1))*z(m,n+7*(o-1))*k*dz;
C(i,nodematnum(m+1,n+7*(o-1)))= -xu(m,n+7*(o-1))*z(m,n+7*(o-1))*k*dz;
C(i,nodematnum(m-1,n+7*(o-1)))= -xd(m,n+7*(o-1))*z(m,n+7*(o-1))*k*dz;
constants(i,1)= h(m,n+7*(o-1))*dx^2*Tinf(m,n+7*(o-1));
i=i+1;
else
end
end
end
end
C=C(:,2:211);

% Convert Temps to Fahrenheit
% F_inf=zeros(size(T_inf));
% for m=1:16
% for n=1:7
% for o=1:5
% if Tinf(m,n+7*(o-1)) != 0
% Finf(m,n+7*(o-1))=(Tinf(m,n+7*(o-1))-273)*9/5+32;
% else
% end
% end
% end
% end

